﻿<%@ WebHandler Language="C#" Class="MachineInformation" %>

using System;
using System.IO;
using System.Web;
using System.Text;
using System.Xml;

public class MachineInformation : IHttpHandler
{
        private float _used = 0;
            private float _free = 0;
            private float _cpu = 0;
    
            public float GetTotal()
            {
                return _free + _used;
            }

          

            public float GetPercentageFree()
            {
                return _free / GetTotal();
            }

            public float GetPercentageUsed()
            {
                return _used / GetTotal();
            }

    public void ProcessRequest (HttpContext context) {
            context.Response.ContentType = "text/xml";
          try{
        StringBuilder sb = new StringBuilder();
        using(TextWriter txtWriter = new StringWriter(sb)  ) {
            using (XmlTextWriter writer = new XmlTextWriter(txtWriter))
            {
                GetReading();
                writer.WriteStartDocument();
                writer.WriteStartElement("properties");
                writer.WriteElementString("freeMemoryPercentage", GetPercentageFree().ToString());
                writer.WriteElementString("usedMemoryPercentage", GetPercentageUsed().ToString());
                writer.WriteElementString("cpuUsagePercentage", _cpu.ToString());
                writer.WriteEndElement();
                writer.WriteEndDocument();
                context.Response.Write(sb.ToString());
            }
            
        }
		}catch(Exception ex) {
			context.Response.Write("Error: " + ex.Message);
		}
    }
 
    public bool IsReusable {
        get {
            return false;
        }
    }


    private void GetReading()
    {
        System.Diagnostics.PerformanceCounter cpuCounter = new System.Diagnostics.PerformanceCounter("Processor", "% Processor Time", "_Total"); 
        cpuCounter.NextValue();
	System.Threading.Thread.Sleep(1000);
        System.Diagnostics.PerformanceCounter freeMemCounter = new System.Diagnostics.PerformanceCounter("Memory", "Available KBytes");
        _free = freeMemCounter.NextValue();
        System.Diagnostics.PerformanceCounter usedMemCounter = new System.Diagnostics.PerformanceCounter("Memory", "Committed Bytes");
        _used = usedMemCounter.NextValue() / 1000;
        _cpu = cpuCounter.NextValue() / 100;
        
       
    }
    
    
    

}